CATREFS = {"contemporary": "The manuscript source is contemporary with the authorial version of the text.",
"non-contemporary": "The manuscript source is not contemporary with the authorial version of the text.",
"same": "The manuscript source is the authorial version of the text.",
"unknown": "The relationship of the manuscript source to the authorial version of the text is unknown.",
"A-X": "Anglian dialect of Old English with unknown features.",
"AM": "Anglian Mercian dialect of Old English.",
"AM-X": "Anglian Mercian dialect of Old English with unknown features.",
"AN": "Anglian Northumbrian dialect of Old English.",
"K": "Kentish dialect of Old English.",
"K-X": "Kentish dialect of Old English with unknown features.",
"WS": "West Saxon dialect of Old English.",
"WS-K": "West Saxon dialect of Old English with Kentish features.",
"WS-A": "West Saxon dialect of Old English with Anglian features.",
"WS-AM": "West Saxon dialect of Old English with Anglian Mercian features.",
"WS-X": "West Saxon dialect of Old English with unknown features.",
"EML": "East Midlands dialect of Middle English, identified by LALME.",
"EML-NL": "East Midlands dialect of Middle English with Northern features, identified by LALME.",
"EMO": "East Midlands dialect of Middle English, identified by other sources.",
"WML": "West Midlands dialect of Middle English, identified by LALME.",
"WMO": "West Midlands dialect of Middle English, identified by other sources.",
"NL": "Northern dialect of Middle English, identified by LALME.",
"NO": "Northern dialect of Middle English, identified by other sources.",
"NO-EMO": "Northern dialect of Middle English with East Midlands features, identified by other sources.",
"SL": "Southern dialect of Middle English, identified by LALME.",
"SO": "Southern dialect of Middle English, identified by other sources.",
"KL": "Kentish dialect of Middle English, identified by LALME.",
"KO": "Kentish dialect of Middle English, identified by other sources.",
"ME": "Unidentified dialect of Middle English.",
"ENGLISH": "Early Modern English.",
"verse": "The text is in verse form.",
"prose": "The text is in prose form.",
"law": "law",
"docum": "document",
"handb.astronomy": "handbook, astronomy",
"handb.medicine": "handbook, medicine",
"handb.other": "handbook, other",
"science.astronomy": "science, astronomy",
"science.medicine": "science, medicine",
"science.other": "science, other",
"educ.treat": "educational treatise",
"philosophy": "philosophy",
"homily": "homily",
"sermon": "sermon",
"rule": "rule",
"rel.treat": "religious treatise",
"preface_epil": "preface/epilogue",
"proc.depos": "proceeding, deposition",
"proc.trial": "proceeding, trial",
"history": "history",
"geography": "geography",
"travelogue": "travelogue",
"diary.priv": "private diary",
"biogr.life.saint": "biography, life of saint",
"biogr.auto": "biography, autobiography",
"biogr.other": "biography, other",
"fiction": "fiction",
"romance": "romance",
"drama.myst": "drama, mystery play",
"drama.comedy": "drama, comedy",
"let.priv": "letter, private",
"let.non-priv": "letter, not private",
"bible": "the bible",
"x": "unknown text type",
"gloss": "The text is a gloss of a foreign original.",
"transl": "The text is a translation of a foreign original.",
"x.orig": "The texts relationship to foreign originals is unknown.",
"Latin": "The text is a translation or gloss of a Latin original.",
"Latin-French": "The text is a translation or gloss of a Latin and French original.",
"French": "The text is a translation or gloss of a French original.",
"Dutch": "The text is a translation or gloss of a Dutch original.",
"Other": "The text is a translation or gloss of an original in some other language.",
"NA": "The text is either not a translation or a translation from an unknown source language.",
"written": "The text is a written text.",
"speech-based": "The text is written text based on spoken language.",
"script": "The text is a written text intended for spoken performance.",
"x.spoken": "The texts relationship to spoken language is unknown.",
"male": "The author is male.",
"female": "The author is female.",
"unknown_sex": "The authors sex is unknown.",
"age_under20": "The authors age is under 20 years.",
"age_20-40": "The authors age is between 20 and 40 years.",
"age_40-60": "The authors age is between 40 and 60 years.",
"age_over60": "The authors age is over 60 years.",
"age_X": "The authors age is unknown.",
"rank_high": "The person represents the higher ranks of society.",
"rank_prof": "The person represents the professional class.",
"rank_other": "The person represents some other class than professional or higher ranks.",
"rank_x": "The social rank of the person is unknown.",
"rank_high-prof": "The person is moving from higher social ranks to the professional class.", 
"rank_prof-high": "The person is moving from the professional class to the higher social ranks.",
"rank_high-other": "The person is moving from higher social ranks to some other rank.",
"rank_other-high": "The person is moving from some other rank to the higher social ranks.",
"rank_prof-other": "The person is moving from the professional class to some other rank.",
"rank_other-prof": "The person is moving from some other rank to the professional class.",
"aud_prof": "Written for a professional audience.",
"aud_non-prof": "Written for a non-professional audience.",
"aud_x": "Written for an unknown audience.",
"int.down": "Intimate relationship and inferior position in relation to author.",
"int.up": "Intimate relationship and superior position in relation to author.",
"int.equal": "Intimate relationship and equal position in relation to author.",
"dist.down": "Distant relationship and inferior position in relation to author.",
"dist.up": "Distant relationship and superior position in relation to author.",
"dist.equal": "Distant relationship and equal position in relation to author.",
"x.x": "Unknown position in relation to author.",
"interactive": "The text can be considered interactive.",
"non-interactive": "The text cannot be considered interactive.",
"formal": "The setting of the text is formal.",
"informal": "The setting of the text is informal.",
"x.setting": "The setting of the text is unknown.",
"stat": "statutory",
"instr.sec": "instruction, secular",
"instr.rel": "instruction, religious",
"expos": "expository",
"narr.non-imag": "narrative, non-imaginary",
"narr.imag": "narrative, imaginary",
"x.proto": "unknown"}
