# How to clean up after a corpus has been successfully published
After a corpus has been published, all associated data should be removed from Puhti. Before the clean-up, you should ensure that the source data has been backed up on the HFST server, and that the package has been published successfully in Korp or the Download Service.

## Source and VRT versions
Source and VRT versions of a corpus are published in the Download Service. After a corpus has been successfully published (tested on the service and news are published), the download package, MD5 checksum file, README and LICENSE files should be removed from the directory `/scratch/clarin/download_preview` on Puhti.
Also related data used for creating the package and stored in some other place on Puhti (e.g. the personal scratch folder), should be removed at this point.

## Korp corpora
For Korp versions the cleaning of any conversion data from Puhti should be done after the beta status has been removed from the published corpus.

Usually the person who ran korp-make would also clean up the packages and other data generated by korp-make, that is `/scratch/clarin/korp/corpora/pkgs/corpusid/*` and `/scratch/clarin/korp/corpora/vrt/corpusid/*` where `corpusid` is the Korp corpus id for a (sub)corpus.
The data in `/scratch/clarin/korp/corpora/data/corpusid/*` and `/scratch/clarin/korp/corpora/registry/corpusid` (a single file) should also be removed. 
Make sure to remove the directories (e.g. /scratch/clarin/korp/corpora/data/corpusid), too, after removing the files in them.

Korp versions should also be removed from the testing environment of Korp (Korp test version), after the beta status has been removed from the published corpus.


